import {createEffect, createSignal} from "solid-js";
import styles from "./Tabbed.module.css";

export default function Tabbed(props) {
    let [current_tab, set_current_tab] = createSignal(0);

    let children = props.children;

    if (!Array.isArray(children)) children = [children];

    return <div class={styles.Tabbed}>
        <ol class={styles.header}>
            <For each={children.map(item => item.title)}>
                {(item, index) => {
                    return <li
                        class={current_tab() == index() ? styles.active : null}
                        onClick={() => set_current_tab(index())}
                    >{item}</li>;
                }}
            </For>
        </ol>
        <ol class={styles.container}>
            <For each={children}>
                {(item, index) => {
                    return <li class={styles.body} class={current_tab() == index() ? styles.active : null}>{item}</li>
                }}
            </For>
        </ol>
    </div>
}
