import {createEffect} from "solid-js";

import styles from "./input.module.css";

export default function Direction(props) {
    let {value, setValue} = props;
    let select;

    createEffect(() => {
        select.value = value();
    });

    return (<select class={styles.select} title="Direction" ref={select} onChange={() => setValue(select.value)}>
        <option value="Up" default>Up</option>
        <option value="Right">Right</option>
        <option value="Down">Down</option>
        <option value="Left">Left</option>
    </select>);
}
