import {createEffect} from "solid-js";
import styles from "./input.module.css";

export default function Value(props) {
    let {value, setValue} = props;

    let select;

    createEffect(() => {
        if (select) {
            select.value = Object.keys(value())[0];
        }
    });

    return (<>
        <Show when={setValue}>
            <select title="Type" ref={select} class={styles.select_type} onChange={(evt) => {
                if (!(select.value in value())) {
                    if (select.value === "Number") {
                        setValue({"Number": 0.0});
                    } else if (select.value === "String") {
                        setValue({"String": ""});
                    }
                }
            }}>
                <option value="Number" title="Number" default>N</option>
                <option value="String" title="String">S</option>
            </select>
            <Switch>
                <Match when={"Number" in value()}>
                    <input
                        class={styles.input}
                        type="number"
                        value={value()["Number"]}
                        onChange={(evt) => {
                            setValue({"Number": +evt.currentTarget.value});
                        }}
                    />
                </Match>
                <Match when={"String" in value()}>
                    "<input
                        class={styles.input}
                        type="string"
                        value={value()["String"]}
                        onChange={(evt) => {
                            setValue({"String": evt.currentTarget.value});
                        }}
                    />
                    "
                </Match>
            </Switch>
        </Show>
        <Show when={!setValue}>
            <Switch>
                <Match when={"Number" in value()}>
                    {value()["Number"]}
                </Match>
                <Match when={"String" in value()}>
                    "{value()["String"]}"
                </Match>
            </Switch>
        </Show>
    </>);
}
